# Requires files needed for wrapping the plain Iup libraries.
#
require 'securerandom'

require 'iup-ffi-plain'

# helper code
require 'wrapped/attribute-builders'
require 'wrapped/attribute-reference'
require 'wrapped/dynamic-fill-methods'
require 'wrapped/common-attributes'
require 'wrapped/image-attributes'
require 'wrapped/callback-setter'
require 'wrapped/drag-drop-attributes'
require 'wrapped/internal-drag-drop-attributes'
require 'wrapped/scrollbar-attributes'

# the wrapper classes themselves
# -- core libraries
require 'wrapped/dialogs'

require 'wrapped/widget'
require 'wrapped/button'
require 'wrapped/canvas'
require 'wrapped/frame'
require 'wrapped/label'
require 'wrapped/link'
require 'wrapped/list'
require 'wrapped/progressbar'
require 'wrapped/tabs'
require 'wrapped/text'
require 'wrapped/toggle'
require 'wrapped/tree'
require 'wrapped/val'

# -- dialogs
require 'wrapped/colourdialog'
require 'wrapped/dialog'
require 'wrapped/filedialog'
require 'wrapped/fontdialog'
require 'wrapped/messagedialog'
require 'wrapped/progressdialog'

# -- resources
require 'wrapped/image'
require 'wrapped/menu'
require 'wrapped/menuitem'
require 'wrapped/separator'
require 'wrapped/submenu'
require 'wrapped/timer'

# -- layout
require 'wrapped/background-box'
require 'wrapped/expander'
require 'wrapped/fill'
require 'wrapped/gridbox'
require 'wrapped/hbox'
require 'wrapped/radio'
require 'wrapped/scrollbox'
require 'wrapped/splitbox'
require 'wrapped/stretchbox'
require 'wrapped/vbox'
require 'wrapped/zbox'

# -- extensions
require 'wrapped/scintilla'

# -- additional controls
require 'wrapped/colourbar'
require 'wrapped/dial'
require 'wrapped/matrix'

# -- global methods
require 'wrapped/iup-global' 

