require 'ffi'
require 'rbconfig'

module ControlsLib # :nodoc:
  extend FFI::Library

  case RbConfig::CONFIG['host_os']
    #  when /mswin|mingw/
    #    ffi_lib 'lib/library/iupcontrols.dll'
  when /linux|cygwin/
    ffi_lib 'libiupcontrols'
  else
    raise Exception, 'iup libraries not found for this platform'
  end

  attach_function :IupControlsOpen, [], :int

  # -- additional
  #  attach_function :IupCells, [], :pointer
  attach_function :IupColorbar, [], :pointer
  #  attach_function :IupColorBrowser, [], :pointer
  attach_function :IupDial, [:string], :pointer
  attach_function :IupMatrix, [:string], :pointer
  #  attach_function :IupMatrixList, [], :pointer
  #  attach_function :IupMatrixEx, [], :pointer
  #  attach_function :IupWebBrowser, [], :pointer
end
