require 'ffi'
require 'rbconfig'

module ImgLib # :nodoc:
  extend FFI::Library

  case RbConfig::CONFIG['host_os']
  when /mswin|mingw/
    ffi_lib 'lib/library/iupimglib.lib'
  when /linux|cygwin/
    ffi_lib 'libiupimglib'
  else
    raise Exception, 'iup libraries not found for this platform'
  end

  attach_function :IupImageLibOpen, [], :void
end
