module Iup

  # Dynamically fills empty space. Its parent _must_ be an HBox or VBox.
  #
  # == Attributes
  #
  # expand:: <b>read-only</b>, 'horizontal' if in an HBox, or 'vertical' if 
  #          in a VBox.
  # position:: <b>read-only</b> returns position in pixels within client window
  #            as "x,y".
  # rastersize:: Size of the widget, in pixels, value as "widthxheight".
  #
  class Fill < Widget

    # Creates an instance of Fill.
    # Note that attributes must be set separately, not through a block.
    def initialize
      @handle = IupLib.IupFill
    end

    define_readonly :expand
    define_readonly :position
    define_attribute :rastersize
  end
end

