module Iup

  # Defines attributes for widgets which contain images.
  #
  module ImageAttributes
    include AttributeReference

    # Sets the image to display, based on an image or image name.
    # This can use an actual image object, or the name of an image 
    # from +IupImageLib+.
    def image val=nil
      attribute_reference 'IMAGE', ImageWidget, val
    end

    # Sets the image to display when inactive, based on an image or image name.
    def iminactive val=nil
      attribute_reference 'IMINACTION', ImageWidget, val
    end

    # Sets the image to display when pressed, based on an image or image name.
    def impress val=nil
      attribute_reference 'IMPRESS', ImageWidget, val
    end
  end

end

